<?php
/* XooNIps2WEKO Module
 * include/functions.php
 * $Revision: 1.10
 */

include_once dirname(dirname(dirname(dirname( __FILE__ )))).'/mainfile.php';

//XooNIps
include_once dirname(dirname(dirname(__FILE__))).'/xoonips/condefs.php';
include_once dirname(dirname(dirname(__FILE__))).'/xoonips/include/functions.php';
include_once dirname(dirname(dirname(__FILE__))).'/xoonips/include/imexport.php';

//xnparticle
include_once  dirname(dirname(dirname(__FILE__))).'/xnparticle/include/view.php';

if (!defined('XOONIPS2WEKO_PATH')) {
	define('XOONIPS2WEKO_PATH', XOOPS_ROOT_PATH . '/modules/xoonips2weko');
}

/*
 * uid で指定したユーザが moderator グループに属しているか確認する
 */
function is_moderator($uid)
{
	global $xoopsDB;

	$ret = false;

	$sql = "SELECT value FROM ".$xoopsDB->prefix("xoonips_config")
	       ." WHERE name='moderator_gid'";
	if ($result = $xoopsDB->query($sql)) {
		list($moderator_gid) = $xoopsDB->fetchRow($result);
		$sql = "SELECT * from ".$xoopsDB->prefix("groups_users_link")
		       ." WHERE groupid=${moderator_gid}"
		       ." AND uid=${uid}";

		if (($result = $xoopsDB->query($sql))
		    && $xoopsDB->getRowsNum($result) > 0) {
			$ret = true;
		} else {
			$ret = false;
		}
	} else {
		$ret = false;
	}

	return $ret;
}

/*
 * item_ids から item_type_id のアイテムだけを抽出して返す
 */
function filter_by_item_type_id($item_ids, $item_type_id)
{
	$new_item_ids = array();
	foreach ($item_ids as $item_id) {
		$ret = get_item_basic($item_id, $basic);
		if (!$ret)
			continue;

		if ($basic['item_type_id'] == $item_type_id)
			$new_item_ids[] = $item_id;
	}

	return $new_item_ids;
}

/*
 * 2つのファイルが同じものか確認する
 * 同じ : true
 * 違う : false
 */
function is_same_file($a, $b)
{
	if (!file_exists($a) || !file_exists($b))
		return false;

	$a_size = filesize($a);
	$b_size = filesize($b);

	if ($a_size != $b_size)
		return false;

	$a_content = file_get_contents($a);
	$b_content = file_get_contents($b);

	if ($a_content === $b_content)
		return true;
	else
		return false;
}

/*
 * エクスポート済みのファイルが存在するか確認する
 */
function find_old_files($item_type_name)
{
	$filename = "xoonips_" . ucfirst($item_type_name);
	$ret = glob("/tmp/$filename*.tar.gz");
	return $ret;
}

/*
 * エクスポート済みのファイルを削除する
 */
function delete_old_files($item_type_name)
{
	$olds = find_old_files($item_type_name);
	if (empty($olds))
		return true;

	$ret = true;
	foreach ($olds as $f) {
		if (!unlink($f)) {
			add_log("Warning can not delete $f\n");
			$ret = false;
		}
	}
	return $ret;
}

/*
 * 特定のアイテムタイプのアイテム数を返す
 */
function get_item_count_by_item_type($item_type_id)
{
	global $xoopsDB;
	$itemTypeTable = $xoopsDB->prefix("xoonips_item_type");
	$sql = "SELECT name FROM $itemTypeTable WHERE item_type_id = $item_type_id";
	$result = $xoopsDB->query($sql);
	if (!$result)
		return false;
	list($item_type_name) = $xoopsDB->fetchRow($result);

	$pk_name = substr($item_type_name, 3) . "_id"; /* ex. xnparticle -> article_id */
	$itemDetailTable = $xoopsDB->prefix($item_type_name."_item_detail");
	$itemBasicTable = $xoopsDB->prefix("xoonips_item_basic");
	$sql = "SELECT COUNT(*) FROM $itemDetailTable a, $itemBasicTable b WHERE a.$pk_name = b.item_id";
	$result = $xoopsDB->query($sql);
	if (!$result)
		return false;
	list($count) = $xoopsDB->fetchRow($result);
	return $count;
}

/*
 * 全てのアイテムタイプ名とアイテムタイプIDの組を返す
 */
function get_all_item_type()
{
	global $xoopsDB;
	$itemTypeTable = $xoopsDB->prefix("xoonips_item_type");
	$sql = "SELECT item_type_id, display_name FROM $itemTypeTable WHERE mid is not null";
	$result = $xoopsDB->query($sql);
	if (!$result)
		return false;

	$types = array();
	while ($row = $xoopsDB->fetchArray($result)) {
		$count = get_item_count_by_item_type($row['item_type_id']);
		$row['display_name'] .= " ($count)";
		$types[] = $row;
	}
	return $types;
}

/*
 * アイテムタイプ名を指定して変換ルールファイルを読み込む
 */
function get_mapping($item_type)
{
	$filename = XOONIPS2WEKO_PATH . "/metadata/" . ucfirst($item_type) . ".ini";
	if (!file_exists($filename)) {
		add_log("ERROR no exists file $filename\n");
		return false;
	}

	$mapping = @parse_ini_file($filename);
	if ($mapping == false || empty($mapping)) {
		add_log("ERROR failed parse $filename\n");
		return false;
	}

	return $mapping;
}

/*
 * アイテムタイプIDからアイテムタイプ名を取得する
 * (ex. Article, Book, ...)
 */
function get_item_type_name($item_type_id)
{
	global $xoopsDB;
	$item_type_name = "";
	$itemTypeTable = $xoopsDB->prefix("xoonips_item_type");

	$sql = "SELECT display_name FROM $itemTypeTable WHERE item_type_id = $item_type_id";
	$result = $xoopsDB->query($sql);
	if (!$result)
		return false;

	while ($row = $xoopsDB->fetchArray($result)) {
		$item_type_name = $row['display_name'];
	}
	return $item_type_name;
}

/*
 * アイテムタイプ名からアイテムタイプIDを取得する
 */
function get_item_type_id($item_type_name)
{
	global $xoopsDB;
	$item_type_id = false;
	$itemTypeTable = $xoopsDB->prefix("xoonips_item_type");

	$sql = "SELECT item_type_id FROM $itemTypeTable WHERE display_name = '$item_type_name'";
	$result = $xoopsDB->query($sql);
	if (!$result)
		return false;

	while ($row = $xoopsDB->fetchArray($result)) {
		$item_type_id = $row['item_type_id'];
	}
	return $item_type_id;
}

/*
 * ISO8601形式の文字列を返す
 */
function make_date_iso8601($year, $month, $mday)
{
	if (empty($year))
		return false;

	if (!(1 <= $month && $month <= 12))
		return "$year";

	if (!(1 <= $mday && $mday <= 31))
		return "$year-$month";

	return "$year-$month-$mday";
}

/*
 * アイテムのタイトルを取得する
 * 複数ある場合は delimiter で繋げた文字列を返す
 */
function get_item_title($item_id)
{
	global $xoopsDB;
	global $delimiter;
	$title = "";
	$itemTitleTable = $xoopsDB->prefix("xoonips_item_title");

	$sql = "SELECT title FROM $itemTitleTable WHERE item_id = $item_id";
	$result = $xoopsDB->query($sql);
	if (!$result)
		return false;

	$occurrence = false;
	while ($row = $xoopsDB->fetchArray($result)) {
		if (empty($title)) {
			$title = $row['title'];
		} else {
			$occurrence = true;
			$title .= $delimiter . $row['title'];
		}
	}
	if ($occurrence) {
		add_log("title was export as occurrence item\n");
	}
	return $title;
}

/*
 * アイテムのキーワードを取得する
 * 複数ある場合は delimiter で繋げた文字列を返す
 */
function get_item_keywords($item_id)
{
	global $xoopsDB;
	global $delimiter;
	$keyword = "";
	$itemKeywordTable = $xoopsDB->prefix("xoonips_item_keyword");

	$sql = "SELECT keyword FROM $itemKeywordTable WHERE item_id = $item_id";
	$result = $xoopsDB->query($sql);
	if (!$result)
		return false;

	while ($row = $xoopsDB->fetchArray($result)) {
		if (empty($keyword))
			$keyword = $row['keyword'];
		else
			$keyword .= $delimiter . $row['keyword'];
	}
	return $keyword;
}

/*
 * インデックス名からindex id を取得する
 */
function get_index_id($index)
{
	$index_id;
	$title_handler =& xoonips_getormhandler( 'xoonips', 'title' );
	$criteria = new CriteriaCompo( new Criteria( 'title', mb_convert_encoding($index, mb_internal_encoding(), "auto") ) );
	$criteria->add( new Criteria( 'title_id', DEFAULT_INDEX_TITLE_OFFSET ) );
	$indexid_objs =& $title_handler->getObjects( $criteria );
	if ( $indexid_objs ) {
        	$index_id = $indexid_objs[0]->get( 'item_id' );
	} else {
		return false;
	}
	return $index_id;

}

/*
 * indexのアイテムidを取得する
 */
function get_item_ids($index_id, $recursive)
{
	global $uid;
	if (empty($uid)) {
		add_log("ERROR no set uid\n");
		exit();
	}
	$ids = array();
	$tmp_idx = array( $index_id );
	while ( count($tmp_idx) > 0 ) {
        	$i = array_shift( $tmp_idx );

        	$index_item_link_handler =& xoonips_getormhandler( 'xoonips', 'index_item_link' );
        	$index_item_links = $index_item_link_handler -> getByIndexId( $i, $uid );
        	foreach( $index_item_links as $link ){
            		$ids[] = $link -> get( 'item_id' );
        	}

        	if ($recursive) {
        		$child = array();
                	$ret = _get_child_indexes_itemid($i, $child);
                	if (!$ret) {
				return $ids;
                	} else {
                        	foreach( $child as $c ){
                                	array_push( $tmp_idx, $c['item_id'] );
                        	}
                	}
        	} else {
			return $ids;
		}
        }
	return $ids;
}

/*
 *index_id以下のアイテムidを取得する
 */
function _get_child_indexes_itemid($parent_id, &$indexes )
{
	global $uid;
        if (empty($uid)) {
		add_log("ERROR no set uid\n");
		exit();
	}

	global $xoopsDB;
	$groupTable = $xoopsDB->prefix( "xoonips_groups" );
	$groupUserLinkTable = $xoopsDB->prefix( "xoonips_groups_users_link" );
	$indexTable = $xoopsDB->prefix( "xoonips_index" );
	$itemTable = $xoopsDB->prefix( "xoonips_item_basic" );
	$titleTable = $xoopsDB->prefix( "xoonips_item_title" );

	$cond = "parent_index_id = $parent_id";
	$accessRightCond = "1";

	$sql = "SELECT tx.index_id as item_id, tx.parent_index_id, tx.uid, tx.gid, tx.open_level, tx.sort_number ".
		" , ti.item_type_id, ti.creation_date, ti.uid, ti.description, ti.last_update_date, tt.title as title ".
		" FROM      $titleTable as tt, " .
		" $indexTable  AS tx " .
		" LEFT JOIN $itemTable   AS ti on tx.index_id = ti.item_id " .
		" LEFT JOIN $groupUserLinkTable  AS tlink on tlink.gid = tx.gid and tlink.uid = $uid " .
		" LEFT JOIN $groupTable  AS tg on tx.gid = tg.gid " .
		" WHERE $accessRightCond AND ( tx.open_level != 2 OR tx.open_level = 2 AND tg.gid IS NOT NULL ) ".
		" AND tt.title_id=".DEFAULT_ORDER_TITLE_OFFSET." AND tt.item_id=ti.item_id" .
		" AND $cond";
	$result = $xoopsDB->query( $sql );
	if ( !$result ) {
		return false;
	}

	$index_buf = array();
	$orderd_ids = array();
	while ( list( $index_id, $parent_index_id, $owner_uid, $gid, $open_level, $sort_number,
		$item_type_id, $creation_date, $contributor_uid, $description, $last_update_date ) = $xoopsDB->fetchRow( $result ) ){
		$index = array(
			'item_id'          => $index_id        ,
			'parent_index_id'  => $parent_index_id ,
			'owner_uid'        => ( $owner_uid == NULL ) ? 0 : $owner_uid ,
			'owner_gid'        => ( $gid == NULL ) ? 0 : $gid ,
			'open_level'       => $open_level      ,
			'sort_number'      => $sort_number     ,
			'item_type_id'     => $item_type_id    ,
			'creation_date'    => $creation_date   ,
			'contributor_uid'  => $contributor_uid ,
			'titles'           => array()          ,
			'keywords'         => array()          ,
			'description'      => $description     ,
			'last_update_date' => $last_update_date,
		);
		$index_buf[$index_id] = $index;
		$orderd_ids[] = $index_id;
	}

	if ( count( $index_buf ) > 0 ) {
		//get titles of selected item
		$sql = "SELECT item_id, title FROM " . $xoopsDB->prefix( "xoonips_item_title" )
		. " WHERE item_id IN ( " . implode( ",", array_keys( $index_buf ) ) . " ) ORDER BY item_id ASC, title_id ASC";
		$result = $xoopsDB->query( $sql );
		if ( !$result ){
			return false;
		}

		while ( $row = $xoopsDB->fetchArray( $result ) ){
			$index_buf[ $row['item_id'] ]['titles'][] = $row['title'];
		}
		$textutil =& xoonips_getutility( 'text' );
		foreach ( $index_buf as $k => $index ) {
			if ( $index['parent_index_id'] == IID_ROOT && $index['open_level'] == OL_PRIVATE && $index['owner_uid'] == $uid )
				$index_buf[$k]['titles'][DEFAULT_INDEX_TITLE_OFFSET] = XNP_PRIVATE_INDEX_TITLE;
			$index_buf[$k]['html_title'] = $textutil->html_special_chars( $index_buf[$k]['titles'][DEFAULT_INDEX_TITLE_OFFSET] );
		}

		//get keywords of selected item
		$sql = "SELECT item_id, keyword FROM " . $xoopsDB->prefix( "xoonips_item_keyword" )
		. " WHERE item_id IN ( " . implode( ",", array_keys( $index_buf ) ) . " ) ORDER BY item_id ASC, keyword_id ASC";
		$result = $xoopsDB->query( $sql );
		if ( !$result ){
			return false;
		}
		while ( $row = $xoopsDB->fetchArray( $result ) ){
			$index_buf[ $row['item_id'] ]['keywords'][] = $row['keyword'];
		}
	}

	foreach( $orderd_ids as $id ){
		$indexes[] = $index_buf[$id];
	}
	return true;
}

/**
 *エクスポートディレクトリを作成する
 */
function  make_item_dir($dir_num)
{
	$itemdir = "/tmp/item".$dir_num;
	if ( file_exists($itemdir) && is_dir($itemdir) ) {
		$cmd = "rm -fr $itemdir 2>&1";
		exec($cmd, $out, $ret);
		if ($ret) {
			add_log("can not delete $itemdir\n");
			exit();
		}
	}

  	if ( !mkdir( $itemdir, 0755 ) ) return false;
	return $itemdir;
}

/*
 * xnparticleの item_type_idを取得する
 */
function  get_xnparticle_id()
{
	$xnparticle_id = "";
	global $xoopsDB;
	$sql = "SELECT item_type_id FROM " . $xoopsDB->prefix( "xoonips_item_type" );
	$sql .= " WHERE name='xnparticle'"; 
	$result = $xoopsDB->query( $sql );
	if ( !$result ) {
		return false;
	} else {
		while ( $row = $xoopsDB->fetchArray( $result ) ) {
			$xnparticle_id = $row['item_type_id'];
		}
	}
	return $xnparticle_id;
}

/*
 * アイテムのmetadataを一時格納するテンプレートを作成する。
 */
function make_metadata_format ($mapping, &$formats)
{
	$formats = $mapping['metadata'];
	foreach ($formats as $key => $value) {
		$formats[$key] = "";
	}
	return true;
}

/*
 *サニタイズ処理
 */
function metadata_sanitize(&$metadata)
{
	foreach ($metadata as $key => $value ) {
		//改行コード
		$value = preg_replace("/\r\n/", "\\n", $value);
		$value = preg_replace("/\r/", "\\n", $value);
		$value = preg_replace("/\n/", "\\n", $value);
		//タブ
		$value = preg_replace("/\t/", " ", $value);
		//制御コード
		$value = preg_replace('/[\x00-\x09\x0B\x0C\x0E-\x1F\x7F]/', '', $value);

		$metadata[$key] = $value;
	}
	return true;
}

/*
 * 配列を結合する(TSVのレコード、繰り返しアイテム用)
 */
function make_tsv_record_str($items, $sep=false)
{
	$item_str = "";
	if (is_array($items)) {
                // 配列の全要素が空である場合は何も出力させない
                $is_empty = true;
                foreach ($items as $item) {
                        if (!empty($item)) {
                                $is_empty = false;
                        }
                }
                if ($is_empty) {
                        return $item_str;
                }

		$count = 0;
		$item_top = true;
		$array_size = count($items);
		foreach ($items as $item) {
			if ($item_top) {
				if (empty($item)) {
					$item_str = "&EMPTY&";
				} else {
					$item_str = $item;
				}
				$item_top = false;
			} else {
				// sep の指定がない場合はTSVのヘッダの作成となる
				if (!$sep) {
					$item_str = $item_str . "\t" . $item;
				} else {
					if (empty($item)) {
						// 残りの配列が全て空である場合は出力させない
						$is_empty = true;
						for ($i = $count; $i < $array_size; $i++) {
							if (!empty($items[$i])) {
								$is_empty = false;
							}
						}
						if (!$is_empty) {
							$item_str = $item_str . $sep . "&EMPTY&";
						}
					} else {
						$item_str = $item_str . $sep . $item;
					}
				}
			}
			$count++;
		}
	}
	return $item_str;
}

/*
 * xoonips_item_basic テーブルから item_type_id, uid, description, doi, last_update_date, creation_dateを取得する
 */
function get_item_basic($item_id, &$basic)
{
        global $xoopsDB;
	global $condition_type;
	global $time;

	$sql = "";
	switch ($condition_type) {
		//only delete items
		case 1:
			$sql = "SELECT " . $xoopsDB->prefix( "xoonips_item_basic" ) .".*";
			$sql .= " FROM " . $xoopsDB->prefix( "xoonips_item_basic" );
			$sql .= " INNER JOIN " . $xoopsDB->prefix( "xoonips_item_status" );
			$sql .= " ON " . $xoopsDB->prefix( "xoonips_item_basic" ) . ".item_id = " . $xoopsDB->prefix( "xoonips_item_status" ) . ".item_id";
			$sql .= " WHERE " . $xoopsDB->prefix( "xoonips_item_status" ) . ".is_deleted = 1";
			$sql .= " AND " . $xoopsDB->prefix( "xoonips_item_basic" ) . ".item_id = " . $item_id;
                        break;
		//create-date
                case 2:
                        $sql = "SELECT * FROM " . $xoopsDB->prefix( "xoonips_item_basic" );
                        $sql .= " WHERE creation_date > " . $time . " AND item_id = " . $item_id;
                        break;
		//update-date
                case 3:
                        $sql = "SELECT * FROM " . $xoopsDB->prefix( "xoonips_item_basic" );
                        $sql .= " WHERE last_update_date > " . $time . " AND item_id = " . $item_id;
			$result = $xoopsDB->query( $sql );
			if ( !$result ) {
				add_log("ERROR update date items check".$sql."\n");
				return false;
			} else {
				while ( $row = $xoopsDB->fetchArray( $result ) ) {
					$basic = $row;
				}
				if (!empty($basic)) {
					// 新規アイテムかを確認
					if ($basic['creation_date'] == $basic['last_update_date']) {
						add_log("not update items item_id = ".$item_id."\n");
						return false;
					}
					// 更新した操作が公開取り下げかを確認
					$sql = "";
					$sql = "SELECT * FROM " . $xoopsDB->prefix( "xoonips_item_status" );
					$sql .= " WHERE " . $xoopsDB->prefix( "xoonips_item_status" ) . ".is_deleted = 1";
					$sql .= " AND " . $xoopsDB->prefix( "xoonips_item_status" ) . ".deleted_timestamp = " . $basic['last_update_date'];
					$sql .= " AND " . $xoopsDB->prefix( "xoonips_item_status" ) . ".item_id = " . $item_id;
					$result = $xoopsDB->query( $sql );
					if ( !$result ) {
						add_log("ERROR update date items withdraw check".$sql."\n");
					} else {
						$ret = array();
						while ( $row = $xoopsDB->fetchArray( $result ) ) {
							$ret = $row;
						}
						if (!empty($ret)) {
							add_log("withdraw items item_id = ".$item_id."\n");
							return false;
						}
					}
				} else {
					return true;
				}
			}
                        break;
		//delete-date
		case 4:
			$sql = "SELECT " . $xoopsDB->prefix( "xoonips_item_basic" ) .".*";
			$sql .= " FROM " . $xoopsDB->prefix( "xoonips_item_basic" );
			$sql .= " INNER JOIN " . $xoopsDB->prefix( "xoonips_item_status" );
			$sql .= " ON " . $xoopsDB->prefix( "xoonips_item_basic" ) . ".item_id = " . $xoopsDB->prefix( "xoonips_item_status" ) . ".item_id";
			$sql .= " WHERE " . $xoopsDB->prefix( "xoonips_item_status" ) . ".is_deleted = 1";
			$sql .= " AND " . $xoopsDB->prefix( "xoonips_item_status" ) . ".deleted_timestamp > " . $time;
			$sql .= " AND " . $xoopsDB->prefix( "xoonips_item_basic" ) . ".item_id = " . $item_id;
			break;
		default:
        		$sql = "SELECT * FROM " . $xoopsDB->prefix( "xoonips_item_basic" );
        		$sql .= " WHERE item_id = " . $item_id;
	}

        $result = $xoopsDB->query( $sql );
        if ( !$result ) {
		add_log("ERROR get_item_basic false ".$sql."\n");
                return false;
        } else {
                while ( $row = $xoopsDB->fetchArray( $result ) ) {
                        $basic = $row;
                }
        }
        return true;
}

/*
 * users テーブルから unameを取得する
 */
function get_user_name($uid)
{
	$user_name = "";
	global $xoopsDB;
	$sql = "SELECT uname FROM " . $xoopsDB->prefix( "users" );
        $sql .= " WHERE uid = " . $uid;
	$result = $xoopsDB->query( $sql );
	if ( !$result ) {
		add_log("ERROR get_user_name false ".$sql."\n");
		return $user_name;
	} else {
		while ( $row = $xoopsDB->fetchArray( $result ) ) {
			$user_name = $row['uname'];
                }
        }
        return $user_name;
}


/*
 * xnparticle_item_detail テーブルからメタデータを取得する
 */
function get_item_details($item_id, &$details)
{
	$details = xnparticleGetDetailInformation( $item_id );
	return true;
}

/*
 * xnparticle_item_detail_child_sub_title テーブルからメタデータを取得する
 */
function get_item_child_sub_titles($item_id, &$subtitles)
{
	global $delimiter;
	$subtitles = xnparticleGetDetailChildSubTitleInformation( $item_id );
	$article_child_sub_title_id_array = array();
	$article_id_array = array();
	$sub_title_name_array = array();
	$sub_title_kana_array = array();
	$sub_title_romaji_array = array();
	$sub_title_order_array = array();

	if (count($subtitles) > 0) {
		while ( list( $key, list( $article_child_sub_title_id, $article_id, $sub_title_name, $sub_title_kana, $sub_title_romaji, $sub_title_order ) ) = each( $subtitles ) ){

			array_push( $article_child_sub_title_id_array, $article_child_sub_title_id);
			array_push( $article_id_array, $article_id);
			array_push( $sub_title_name_array, $sub_title_name);
			array_push( $sub_title_kana_array, $sub_title_kana);
			array_push( $sub_title_romaji_array, $sub_title_romaji);
			array_push( $sub_title_order_array, $sub_title_order);			
		}
		$subtitles['article_child_sub_title_id'] = make_tsv_record_str($article_child_sub_title_id_array, $delimiter);
		$subtitles['article_id'] =  make_tsv_record_str($article_id_array, $delimiter);
		$subtitles['sub_title_name'] = make_tsv_record_str($sub_title_name_array, $delimiter);
		$subtitles['sub_title_kana'] = make_tsv_record_str($sub_title_kana_array, $delimiter);
		$subtitles['sub_title_romaji'] = make_tsv_record_str($sub_title_romaji_array, $delimiter);
		$subtitles['sub_title_order'] = make_tsv_record_str($sub_title_order_array, $delimiter);
		
	}
	return true;
}

/*
 * xnparticle_item_detail_child_author テーブルからメタデータを取得する
 */
function get_item_child_authors($item_id, &$authors)
{
	global $delimiter;
	$authors = xnparticleGetDetailChildAuthorInformation( $item_id );
	$article_child_author_id_array = array();
	$article_id_array = array();
	$author_id_array = array();
	$author_name_array = array();
	$author_kana_array = array();
	$author_romaji_array = array();
	$author_affiliation_array = array();
	$author_affiliation_translation_array = array();
	$author_role_array = array();
	$author_link_array = array();
	$author_order_array = array();

	if (count($authors) > 0) {
		while ( list( $key, list( $article_child_author_id, $article_id, $author_id, $author_name, $author_kana, $author_romaji, $author_affiliation, $author_affiliation_translation, $author_role, $author_link, $author_order ) ) = each( $authors ) ){
			array_push($article_child_author_id_array, $article_child_author_id);
			array_push($article_id_array, $article_id);
			array_push($author_id_array, $author_id);
                	array_push($author_name_array, $author_name);
                	array_push($author_kana_array, $author_kana);
                	array_push($author_romaji_array, $author_romaji);
                	array_push($author_affiliation_array, $author_affiliation);
                	array_push($author_affiliation_translation_array, $author_affiliation_translation);
                	array_push($author_role_array, $author_role);
                	array_push($author_link_array, $author_link);
                	array_push($author_order_array, $author_order);
		}
		$authors['article_child_author_id'] = make_tsv_record_str($article_child_author_id_array, $delimiter);
		$authors['article_id'] = make_tsv_record_str($article_id_array, $delimiter);
		$authors['author_id'] = make_tsv_record_str($author_id_array, $delimiter);
		$authors['author_name'] = make_tsv_record_str($author_name_array, $delimiter);
		$authors['author_kana'] = make_tsv_record_str($author_kana_array, $delimiter);
		$authors['author_romaji'] = make_tsv_record_str($author_romaji_array, $delimiter);
		$authors['author_affiliation'] = make_tsv_record_str($author_affiliation_array, $delimiter);
		$authors['author_affiliation_translation'] = make_tsv_record_str($author_affiliation_translation_array, $delimiter);
		$authors['author_role'] = make_tsv_record_str($author_role_array, $delimiter);
		$authors['author_link'] = make_tsv_record_str($author_link_array, $delimiter);
		$authors['author_order'] = make_tsv_record_str($author_order, $delimiter);
	}
	return true;
}
 
/*
 * xnparticle_item_detail_child_keywords テーブルからメタデータを取得する
 */
function get_item_child_keywords($item_id, &$keywords)
{
	global $delimiter;
	$keywords = xnparticleGetDetailChildKeywordsInformation( $item_id );
	$article_child_keywords_id_array = array();
	$article_id_array = array();
	$keywords_array = array();
	$keywords_order_array = array();
	
	if (count($keywords) > 0) {
		while ( list( $key, list( $article_child_keywords_id, $article_id, $keyword, $keywords_order ) ) = each( $keywords) ){
			array_push($article_child_keywords_id_array, $article_child_keywords_id);
			array_push($article_id_array, $article_id);
			array_push($keywords_array, $keyword);
			array_push($keywords_order_array, $keywords_order);
		}
		$keywords['article_child_keywords_id'] = make_tsv_record_str($article_child_keywords_id_array, $delimiter);
		$keywords['article_id'] = make_tsv_record_str($article_id_array, $delimiter);
		$keywords['keywords'] = make_tsv_record_str($keywords_array, $delimiter);
		$keywords['keywords_order'] = make_tsv_record_str($keywords_order_array, $delimiter);
	}
	return true;
}

/*
 * xnparticle_item_detail_child_ndc_classifications テーブルからメタデータを取得する
 */
function get_item_child_ndc_classifications($item_id, &$ndc)
{
	global $delimiter;
	$ndc = xnparticleGetDetailChildNdcClassificationsInformation( $item_id );
	$article_child_ndc_classifications_id_array = array();
	$article_id_array = array();
	$ndc_classifications_array = array();
	$ndc_classifications_order_array = array();

        if (count($ndc) > 0) {
		while ( list( $key, list( $article_child_ndc_classifications_id, $article_id, $ndc_classifications, $ndc_classifications_order ) ) = each( $ndc) ){
			array_push($article_child_ndc_classifications_id_array, $article_child_ndc_classifications_id);
			array_push($article_id_array, $article_id);
			array_push($ndc_classifications_array, $ndc_classifications);
			array_push($ndc_classifications_order_array, $ndc_classifications_order);
		}
		$ndc['article_child_ndc_classifications_id'] = make_tsv_record_str($article_child_ndc_classifications_id_array, $delimiter);
		$ndc['article_id'] = make_tsv_record_str($article_id_array, $delimiter);
		$ndc['ndc_classifications'] = make_tsv_record_str($ndc_classifications_array, $delimiter);
		$ndc['ndc_classifications_order'] = make_tsv_record_str($ndc_classifications_order_array, $delimiter);
	}
	return true;
}

/*
 * xnparticle_item_detail_child_physical_descriptions テーブルからメタデータを取得する
 */
function get_item_child_physical_descriptions($item_id, &$formats)
{
	global $delimiter;
	$formats = xnparticleGetDetailChildPhysicalDescriptionsInformation( $item_id );
	$article_child_physical_descriptions_id_array = array();
	$article_id_array = array();
	$physical_descriptions_array = array();
	$physical_descriptions_order_array = array();
	
	if (count($formats) > 0) {
		while ( list( $key, list( $article_child_physical_descriptions_id, $article_id, $physical_descriptions, $physical_descriptions_order ) ) = each($formats) ){
			array_push($article_child_physical_descriptions_id_array, $article_child_physical_descriptions_id);
			array_push($article_id_array, $article_id);
			array_push($physical_descriptions_array, $physical_descriptions);
			array_push($physical_descriptions_order_array, $physical_descriptions_order);
		}
		$formats['article_child_physical_descriptions_id'] = make_tsv_record_str($article_child_physical_descriptions_id_array, $delimiter);
		$formats['article_id'] = make_tsv_record_str($article_id_array, $delimiter);
		$formats['physical_descriptions'] = make_tsv_record_str($physical_descriptions_array, $delimiter);
		$formats['physical_descriptions_order'] = make_tsv_record_str($physical_descriptions_order_array, $delimiter);
	}
	return true;
}

/*
 * xnparticle_item_detail_child_langs テーブルからメタデータを取得する
 */
function get_item_child_langs($item_id, &$languages)
{
	global $delimiter;
	$languages = xnparticleGetDetailChildLangsInformation( $item_id );
	$article_child_langs_id_array = array();
	$article_id_array = array();
	$langs_array = array();
	$langs_order_array = array();

	if (count($languages) > 0) {
		while ( list( $key, list( $article_child_langs_id, $article_id, $langs, $langs_order ) ) = each($languages) ){
			array_push($article_child_langs_id_array, $article_child_langs_id);
			array_push($article_id_array, $article_id);
			array_push($langs_array, $langs);
			array_push($langs_order_array, $langs_order);
		}
		$languages['article_child_langs_id'] = make_tsv_record_str($article_child_langs_id_array, $delimiter);
		$languages['article_id'] = make_tsv_record_str($article_id_array, $delimiter);
		$languages['langs'] = make_tsv_record_str($langs_array, $delimiter);
		$languages['langs_order'] = make_tsv_record_str($langs_order_array, $delimiter);
	}
	return true;
}

/*
 * xnparticle_item_detail_child_id_issns テーブルからメタデータを取得する
 */
function get_item_child_issns($item_id, &$issns)
{
	global $delimiter;
	$issns = xnparticleGetDetailChildIdIssnsInformation( $item_id );
	$article_child_id_issns_id_array = array();
	$article_id_array = array();
	$id_issns_array = array();
	$id_issns_order_array = array();

	if (count($issns) > 0) {
		while ( list( $key, list( $article_child_id_issns_id, $article_id, $id_issns, $id_issns_order ) ) = each( $issns) ){
			array_push($article_child_id_issns_id_array, $article_child_id_issns_id);
			array_push($article_id_array, $article_id);
			array_push($id_issns_array, $id_issns);
			array_push($id_issns_order_array, $id_issns_order);
		}
		$issns['article_child_id_issns_id'] = make_tsv_record_str($article_child_id_issns_id_array, $delimiter);
		$issns['article_id'] = make_tsv_record_str($article_id_array, $delimiter);
		$issns['id_issns'] = make_tsv_record_str($id_issns_array, $delimiter);
		$issns['id_issns_order'] = make_tsv_record_str($id_issns_order_array, $delimiter);
	}
	return true;
}

/*
 * xnparticle_item_detail_child_id_isbns テーブルからメタデータを取得する
 */
function get_item_child_isbns($item_id, &$isbns)
{
	global $delimiter;
	$isbns = xnparticleGetDetailChildIdIsbnsInformation( $item_id );
	$article_child_id_isbns_id_array = array();
	$article_id_array = array();
	$id_isbns_array = array();
	$id_isbns_order_array = array();

	if (count($isbns) > 0) {
		while ( list( $key, list( $article_child_id_isbns_id, $article_id, $id_isbns, $id_isbns_order ) ) = each( $isbns) ){
			array_push($article_child_id_isbns_id_array, $article_child_id_isbns_id);
			array_push($article_id_array, $article_id);
			array_push($id_isbns_array, $id_isbns);
			array_push($id_isbns_order_array, $id_isbns_order);
		}
		$isbns['article_child_id_isbns_id'] = make_tsv_record_str($article_child_id_isbns_id_array, $delimiter);
		$isbns['article_id'] = make_tsv_record_str($article_id_array, $delimiter);
		$isbns['id_isbns'] = make_tsv_record_str($id_isbns_array, $delimiter);
		$isbns['id_isbns_order'] = make_tsv_record_str($id_isbns_order_array, $delimiter);
	}
	return true;
}

/*
 * xnparticle_item_detail_child_id_dois テーブルからメタデータを取得する
 */
function get_item_child_dois($item_id, &$dois)
{
	global $delimiter;
	$dois = xnparticleGetDetailChildIdDoisInformation( $item_id );
	$article_child_id_dois_id_array = array();
	$article_id_array = array();
	$id_dois_array = array();
	$id_dois_order_array = array();

	if (count($dois) > 0) {
		while ( list( $key, list( $article_child_id_dois_id, $article_id, $id_dois, $id_dois_order ) ) = each( $dois) ){
			array_push($article_child_id_dois_id_array, $article_child_id_dois_id);
			array_push($article_id_array, $article_id);
			array_push($id_dois_array, $id_dois);
			array_push($id_dois_order_array, $id_dois_order);
		}
		$dois['article_child_id_dois_id'] = make_tsv_record_str($article_child_id_dois_id_array, $delimiter);
		$dois['article_id'] = make_tsv_record_str($article_id_array, $delimiter);
		$dois['id_dois'] = make_tsv_record_str($id_dois_array, $delimiter);
		$dois['id_dois_order'] = make_tsv_record_str($id_dois_order_array, $delimiter);
	}
	return true;
}

/*
 * xnparticle_item_detail_child_id_uris テーブルからメタデータを取得する
 */
function get_item_child_id_uris($item_id, &$id_uris)
{
	global $delimiter;
	$id_uris = xnparticleGetDetailChildIdUrisInformation( $item_id );
	$article_child_id_uris_id_array = array();
	$article_id_array = array();
	$id_uris_array = array();
	$id_uris_order_array = array();

	if (count($id_uris) > 0) {
		while ( list( $key, list( $article_child_id_uris_id, $article_id, $id_uri, $id_uris_order ) ) = each($id_uris) ){
			array_push($article_child_id_uris_id_array, $article_child_id_uris_id);
			array_push($article_id_array, $article_id);
			array_push($id_uris_array, $id_uri);
			array_push($id_uris_order_array, $id_uris_order);
		}
		$id_uris['article_child_id_uris_id'] = make_tsv_record_str($article_child_id_uris_id_array, $delimiter);
		$id_uris['article_id'] = make_tsv_record_str($article_id_array, $delimiter);
		$id_uris['id_uris'] = make_tsv_record_str($id_uris_array, $delimiter);
		$id_uris['id_uris_order'] = make_tsv_record_str($id_uris_order_array, $delimiter);
	}
	return true;
}

/*
 * xnparticle_item_detail_child_id_locals テーブルからメタデータを取得する
 */
function get_item_child_locals($item_id, &$locals)
{
	global $delimiter;
	$locals = xnparticleGetDetailChildIdLocalsInformation( $item_id );
	$article_child_id_locals_id_array = array();
	$article_id_array = array();
	$id_locals_array = array();
	$id_locals_order_array = array();

        if (count($locals) > 0) {
		while ( list( $key, list( $article_child_id_locals_id, $article_id, $id_locals, $id_locals_order ) ) = each( $locals) ){
			array_push($article_child_id_locals_id_array, $article_child_id_locals_id);
			array_push($article_id_array, $article_id);
			array_push($id_locals_array, $id_locals);
			array_push($id_locals_order_array, $id_locals_order);
		}
		$locals['article_child_id_locals_id'] = make_tsv_record_str($article_child_id_locals_id_array, $delimiter);
		$locals['article_id'] = make_tsv_record_str($article_id_array, $delimiter);
		$locals['id_locals'] = make_tsv_record_str($id_locals_array, $delimiter);
		$locals['id_locals_order'] = make_tsv_record_str($id_locals_order_array, $delimiter);
	}
	return true;
}

/*
 * xnparticle_item_detail_child_uris テーブルからメタデータを取得する
 */
function get_item_child_uris($item_id, &$uris)
{
	global $delimiter;
	$uris = xnparticleGetDetailChildUrisInformation( $item_id );
	$article_child_uris_id_array = array();
	$article_id_array = array();
	$uris_array = array();
	$uris_order_array = array();

	if (count($uris) > 0) {
		while ( list( $key, list( $article_child_uris_id, $article_id, $uri, $uris_order ) ) = each( $uris ) ){
			array_push($article_child_uris_id_array, $article_child_uris_id);
			array_push($article_id_array, $article_id);
			array_push($uris_array, $uri);
			array_push($uris_order_array, $uris_order);
		}
		$uris['article_child_uris_id'] = make_tsv_record_str($article_child_uris_id_array, $delimiter);
		$uris['article_id'] = make_tsv_record_str($article_id_array, $delimiter);
		$uris['uris'] = make_tsv_record_str($uris_array, $delimiter);
		$uris['uris_order'] = make_tsv_record_str($uris_order_array, $delimiter);
	}
	return true;
}

/*
 * xoonips_changelog テーブルから更新履歴を取得する
 */
function get_item_change_log($item_id, &$changelog)
{
	global $delimiter;
	global $xoopsDB;
	$changelog_array = array();

	$sql = "SELECT log_date, log FROM " . $xoopsDB->prefix( "xoonips_changelog" );
        $sql .= " WHERE item_id = '" . $item_id . "' ORDER BY log_date DESC;";
	$result = $xoopsDB->query( $sql );
	if ( !$result ) {
		return false;
	} else {
		while ( $row = $xoopsDB->fetchArray( $result ) ) {
			$date = date("M j, Y", $row['log_date']);
			$changelog_str = $date . "  " . $row['log'];
			array_push($changelog_array, $changelog_str);
		}
		$changelog['log'] = make_tsv_record_str($changelog_array, $delimiter);
	}
	return true;
}

/*
 * xoonips_related_to テーブルから関連アイテムを取得する
 */
function get_item_related($item_id, &$related)
{
	global $delimiter;
	global $xoopsDB;
	$related_array = array();

	$sql = "SELECT * FROM " . $xoopsDB->prefix( "xoonips_related_to" );
	$sql .= " WHERE parent_id = '" . $item_id . "' ORDER BY related_to_id ASC;";
	$result = $xoopsDB->query( $sql );
	if ( !$result ) {
		return false;
	} else {
		while ( $row = $xoopsDB->fetchArray( $result ) ) {
			array_push($related_array, $row['item_id']);
		}
		$related['related'] = make_tsv_record_str($related_array, $delimiter);
	}
	return true;
}

/*
 * xoonips_ranking_viewed_item テーブルから閲覧数を取得する
 */
function get_ranking_viewed_item($item_id)
{
	$views = 0;
	global $xoopsDB;
        $sql = "SELECT count FROM " . $xoopsDB->prefix( "xoonips_ranking_viewed_item" );
        $sql .= " WHERE item_id = '" . $item_id . "';";
        $result = $xoopsDB->query( $sql );
        if ( !$result ) {
                return $views;
        } else {
                while ( $row = $xoopsDB->fetchArray( $result ) ) {
                        $views = $row['count'];
                }
        }
	return $views;
}

/*
 * xoonips_ranking_downloaded_item テーブルからダウンロード数を取得する
 */
function get_ranking_downloaded_item($item_id)
{
	$downloaded = 0;
	global $xoopsDB;
	$sql = "SELECT count FROM " . $xoopsDB->prefix( "xoonips_ranking_downloaded_item" );
	$sql .= " WHERE item_id = '" . $item_id . "';";
        $result = $xoopsDB->query( $sql );
	if ( !$result ) {
		return $downloaded;
        } else {
                while ( $row = $xoopsDB->fetchArray( $result ) ) {
                        $downloaded = $row['count'];
                }
        }
        return $downloaded;
}

/*
 * NII資源タイプ名をWEKOアイテム名に変換する
 */
function get_weko_item_name($nii_type)
{
	$weko_item_name = "";
	global $weko_item_names;

	switch($nii_type) {
		case "Journal Article":
			$weko_item_name = $weko_item_names['journal_article'];
			break;
		case "Thesis or Dissertation":
			$weko_item_name = $weko_item_names['thesis_or_Dissertation'];
			break;
		case "Departmental Bulletin Paper":
			$weko_item_name = $weko_item_names['departmental_bulletin_paper'];
			break;
		case "Conference Paper":
			$weko_item_name = $weko_item_names['conference_paper'];
			break;
		case "Presentation":
			$weko_item_name = $weko_item_names['presentation'];
			break;
		case "Book":
			$weko_item_name = $weko_item_names['book'];
			break;
		case "Technical Report":
			$weko_item_name = $weko_item_names['technical_report'];
			break;
		case "Research Paper":
			$weko_item_name = $weko_item_names['research_paper'];
			break;
		case "Article":
			$weko_item_name = $weko_item_names['article'];
			break;
		case "Preprint":
			$weko_item_name = $weko_item_names['preprint'];
			break;
		case "Learning Material":
			$weko_item_name = $weko_item_names['learning_material'];
			break;
		case "Data or Dataset":
			$weko_item_name = $weko_item_names['data_or_dataset'];
			break;
		case "Software":
			$weko_item_name = $weko_item_names['software'];
			break;
		case "Others":
			$weko_item_name = $weko_item_names['others'];
			break;
		default:
			$weko_item_name = "";
	}
	return $weko_item_name;

}

/*
 * アイテムのファイル情報を取得する
 */
function get_file_info($item_id)
{
	global $xoopsDB;
	$item_id = (int)$item_id;
	$columns = "t_file.file_id, t_file_type.name, t_file.original_file_name, t_file.file_size, t_file.mime_type, t_file.thumbnail_file, t_file.caption";
	$condition = "item_id = ${item_id} and is_deleted=0";

	$sql = "select $columns from " .
	$xoopsDB->prefix("xoonips_file") . " as t_file, " .
	$xoopsDB->prefix("xoonips_file_type") . " as t_file_type " .
	" where t_file.file_type_id = t_file_type.file_type_id and $condition";

	$result = $xoopsDB->query( $sql );
	if ( !$result) {
		add_log("ERROR get_file_info: $sql " . mysql_error() . "\n");
		return false;
	}

	$files = array();
	while ( false != ( $row = $xoopsDB->fetchRow($result) ) ) {
		$files[] = $row;
	}
	return $files;
}

/*
 * アイテムidの本文ファイルの容量の合計をMBで返す
 */
function get_file_size($item_id)
{
	$file = get_file_info($item_id);
	
	$size = 0;
	foreach ($file as $f) {
		$file = array();
		list( $file['file_id'], $file['file_type_name'], $file['original_file_name'], $file['file_size'], $file['mime_type'], $file['thumbnail_file'], $file['caption'] ) = $f;
		$size += $file['file_size'];
	}
	return round($size/(1024*1024), 1);
}

/*
 * アイテムが配置されているインデックスを返す
 */
function get_item_indexes($item_id, &$indexpath)
{
	global $delimiter;
	$indexes = array();
	$index_ids = array();
	$result = get_index_id_by_item_id($item_id, $index_ids);
	if (!$result) {
		return false;
	} else {
		foreach ($index_ids as $index_id ) {
			$index = array();
			$result = get_index_name($index_id, $index);
			if ( !$result) {
				return false;
			} else {
				$indexes[] = $index;
			}
		}
	}

	$path = array();
	foreach($indexes as $key => $value ) {
		$xid = $indexes[$key]['item_id'];
		$index_path = get_index_path($xid);
		array_push($path, $index_path);
	}
	
	$indexpath['index'] = make_tsv_record_str($path, "|");

	return true;
}

/*
 * アイテムidからindexのidを取得する
 * xnp_get_index_id_by_item_id
 */
function get_index_id_by_item_id($item_id, &$index_ids)
{
	$item_id = (int)$item_id;
	$index_ids = array();
	
	global $xoopsDB;
	$sql = "SELECT index_id FROM " . $xoopsDB->prefix( "xoonips_index_item_link" );
	$sql .= " WHERE item_id = $item_id ;";
	$result = $xoopsDB->query( $sql );
	if (!$result) {
		return false;
	} else {
		while ( list($index_id) = $xoopsDB->fetchRow($result)) {
			$index_ids[] = $index_id;
		}
	}
	return true;
}

/*
 * インデックス名を取得する
 * xnp_get_index
 */
function get_index_name($index_id, &$index)
{
	$index_id = (int)$index_id;
	$index = array();

	$cond = " index_id = $index_id ";
	$indexes = array();
	$result = get_indexes_internal( $cond, $indexes );
	if ($result && !isset($indexes[0])) {
		return false;
	} else {
		$index = $indexes[0];
	}
	return true;
}

/*
 * function _xnpal_getIndexesInternal( $sess_id, $cond, $uid, &$indexes, $criteriaString )
 */
function get_indexes_internal($cond, &$indexes)
{
	global $uid;
	if (empty($uid)) {
		add_log("ERROR no set uid\n");
		exit();
        }

	global $xoopsDB;
	$groupTable = $xoopsDB->prefix( "xoonips_groups" );
	$groupUserLinkTable = $xoopsDB->prefix( "xoonips_groups_users_link" );
	$indexTable = $xoopsDB->prefix( "xoonips_index" );
	$itemTable = $xoopsDB->prefix( "xoonips_item_basic" );
	$titleTable = $xoopsDB->prefix( "xoonips_item_title" );

	$accessRightCond = "1";
	
	$sql = "SELECT tx.index_id as item_id, tx.parent_index_id, tx.uid, tx.gid, tx.open_level, tx.sort_number ".
	" , ti.item_type_id, ti.creation_date, ti.uid, ti.description, ti.last_update_date, tt.title as title ".
	" FROM      $titleTable as tt, " .
	" $indexTable  AS tx " .
	" LEFT JOIN $itemTable   AS ti on tx.index_id = ti.item_id " .
	" LEFT JOIN $groupUserLinkTable  AS tlink on tlink.gid = tx.gid and tlink.uid = $uid " .
	" LEFT JOIN $groupTable  AS tg on tx.gid = tg.gid " .
	" WHERE $accessRightCond AND ( tx.open_level != 2 OR tx.open_level = 2 AND tg.gid IS NOT NULL ) ".
	" AND tt.title_id=".DEFAULT_ORDER_TITLE_OFFSET." AND tt.item_id=ti.item_id" .
	" AND $cond";

	$result = $xoopsDB->query( $sql );
	if (!$result) {
		return false;
	}

	$index_buf = array();
	$orderd_ids = array(); //array of sorted item_id(s) to sort $index_buf in the end of this function
	while ( list( $index_id, $parent_index_id, $owner_uid, $gid, $open_level, $sort_number,
		$item_type_id, $creation_date, $contributor_uid, $description, $last_update_date ) = $xoopsDB->fetchRow( $result ) ){
		$index = array(
		'item_id'          => $index_id        ,
		'parent_index_id'  => $parent_index_id ,
		'owner_uid'        => ( $owner_uid == NULL ) ? 0 : $owner_uid ,
		'owner_gid'        => ( $gid == NULL ) ? 0 : $gid ,
		'open_level'       => $open_level      ,
		'sort_number'      => $sort_number     ,
		'item_type_id'     => $item_type_id    ,
		'creation_date'    => $creation_date   ,
		'contributor_uid'  => $contributor_uid ,
		'titles'           => array()          ,
		'keywords'         => array()          ,
		'description'      => $description     ,
		'last_update_date' => $last_update_date,
		);
		$index_buf[$index_id] = $index;
		$orderd_ids[] = $index_id;
	}

  if ( count( $index_buf ) > 0 ) {
    //get titles of selected item
    $sql = "SELECT item_id, title FROM " . $xoopsDB->prefix( "xoonips_item_title" )
      . " WHERE item_id IN ( " . implode( ",", array_keys( $index_buf ) ) . " ) ORDER BY item_id ASC, title_id ASC";
    $result = $xoopsDB->query( $sql );
    if ( !$result ){
      return false;
    }
    while ( $row = $xoopsDB->fetchArray( $result ) ){
      $index_buf[ $row['item_id'] ]['titles'][] = $row['title'];
    }
    $textutil =& xoonips_getutility( 'text' );
    foreach ( $index_buf as $k => $index ) {
      if ( $index['parent_index_id'] == IID_ROOT && $index['open_level'] == OL_PRIVATE && $index['owner_uid'] == $uid )
        $index_buf[$k]['titles'][DEFAULT_INDEX_TITLE_OFFSET] = XNP_PRIVATE_INDEX_TITLE;
      $index_buf[$k]['html_title'] = $textutil->html_special_chars( $index_buf[$k]['titles'][DEFAULT_INDEX_TITLE_OFFSET] );
    }

    //get keywords of selected item
    $sql = "SELECT item_id, keyword FROM " . $xoopsDB->prefix( "xoonips_item_keyword" )
      . " WHERE item_id IN ( " . implode( ",", array_keys( $index_buf ) ) . " ) ORDER BY item_id ASC, keyword_id ASC";
    $result = $xoopsDB->query( $sql );
    if ( !$result ){
      return false;
    }
    while ( $row = $xoopsDB->fetchArray( $result ) ){
      $index_buf[ $row['item_id'] ]['keywords'][] = $row['keyword'];
    }
  }

  //
  foreach( $orderd_ids as $id ){
	$indexes[] = $index_buf[$id];
  }

  return true;

}

/*
 * アイテムが格納されるインデックスパスを返す
 */
function get_index_path($xid)
{
	$dirArray = array();
	$dirArrayR = array();
	
	for ( $p_xid = $xid; $p_xid != IID_ROOT; $p_xid = (int)($index['parent_index_id']) ) {
		$index = array();
		$result = get_index_name($p_xid, $index);
		if (!$result) {
			break;
		} else {
			$dirArray[] = $index;
		}
	}
	$ct = count($dirArray);
	for ($i=0; $i<$ct; $i++) {
		$dirArrayR[] = $dirArray[ $ct-$i-1 ]['titles'][DEFAULT_INDEX_TITLE_OFFSET];
	}

	//WIndows用 サニタイズ
	$ct = count($dirArrayR);
	for ($i=0; $i<$ct; $i++) {
		$dirArrayR[$i] = windows_sanitize($dirArrayR[$i]);
	}


	$index_path = implode("/", $dirArrayR);
	
	//check length over 200 Byte
	$ret = check_index_str_length($index_path);
	if (!$ret) {
		add_log("Alert index name " . mb_convert_encoding($index_path, "UTF-8", "auto") . " is over 200 Byte \n");
	} 

	return $index_path;
}

/*
 * インデックス名をチェックする
 */
function windows_sanitize($chk_str) {

	$chk_str = mb_convert_encoding($chk_str, "UTF-8", "auto");
	$str = $chk_str;
	//Windows
	if (preg_match("/\\\\/u", $str)) {
		$str = preg_replace("/\\\\/u", "￥", $str);
		add_log("'\\' replace from " . $chk_str . " to " . $str . "\n");
		$chk_str = $str;
	}
	if (preg_match("/\//u", $str)) {
		$str = preg_replace("/\//u", "／", $str);
		add_log("'/' replace from " . $chk_str . " to " . $str . "\n");
		$chk_str = $str;
	}
	if (preg_match("/:/u", $str)) {
		$str = preg_replace("/:/u", "：", $str);
		add_log("':' replace from " . $chk_str . " to " . $str . "\n");
		$chk_str = $str;
	}
	if (preg_match("/\*/u", $str)) {		
		$str = preg_replace("/\*/u", "＊", $str);
		add_log("'*' replace from " . $chk_str . " to " . $str . "\n");
		$chk_str = $str;
	}
	if (preg_match("/\?/u", $str)) {
		$str = preg_replace("/\?/u", "？", $str);
		add_log("'?' replace from " . $chk_str . " to " . $str . "\n");
		$chk_str = $str;
	}
	if (preg_match("/\"/u", $str)) {
		$str = preg_replace("/\"/u", "”", $str);
		add_log("'\"' replace from " . $chk_str . " to " . $str . "\n");
		$chk_str = $str;
	}
	if (preg_match("/</u", $str)) {
		$str= preg_replace("/</u", "＜", $str);
		add_log("'<' replace from " . $chk_str . " to " . $str . "\n");
		$chk_str = $str;
	}
	if (preg_match("/>/u", $str)) {
		$str = preg_replace("/>/u", "＞", $str);
		add_log("'>' replace from " . $chk_str . " to " . $str . "\n");
		$chk_str = $str;
	}
	if (preg_match("/\|/u", $str)) {
		$str = preg_replace("/\|/u", "｜", $str);
		add_log("'|' replace from " . $chk_str . " to " . $str . "\n");
		$chk_str = $str;
	}
	$str = mb_convert_encoding($str, "", "UTF-8");

        return $str;
}

/*
 * ファイルパスの長さが200byte以上かを判定する
 */
function check_index_str_length($index_path)
{
	$str = mb_convert_encoding($index_path, "SJIS", "auto");
	
	if (strlen($str) < 200 ) {
		return true;
	}
	return false;
}

/*
 * 実行状況をログファイルに記録する
 */
function add_log($message) {

	global $logfile;
	if (empty($logfile)) {
		$logfile = "/var/log/xoonips2weko.log";
	}

	if (empty($message)) {
		return;
	}

	$file_info = pathinfo($logfile);
	if ( !file_exists($file_info['dirname']) ) {
		fputs(STDERR, "mkdir " . $file_info['dirname'] . "\n");
		if ( !mkdir( $file_info['dirname'], 0755 ) ) {
			fputs(STDERR, "can not mkdir " . $file_info['dirname'] . "\n");
		}
	}

	$date = date('M  d H:i:s');
	$log = $date . " " . $message;
	if (!error_log($log, 3, $logfile)) {
		fputs(STDERR, "can not write " . $logfile . " message: " . $log . "\n");
	} else {
		fputs(STDERR, $log);

	}
}

