<?php
/* XooNIps2WEKO Module
 * XooNIps to WEKO Metadata Export Command Line Tool
 * xoonips2weko.php
 * $Revision: 1.10
 */
include_once dirname(dirname(dirname( __FILE__ ))).'/mainfile.php';
include_once dirname(__FILE__).'/include/functions.php';

if (!defined('XOONIPS2WEKO_PATH')) {
	define('XOONIPS2WEKO_PATH', XOOPS_ROOT_PATH . '/modules/xoonips2weko');
}

function usage($name)
{
	echo <<<EOF
Usage: $name
       [ -f ini_file ]
       [ -t item_type_id | -p item_type_name ]
       [ -i index_id | -n index_name ]
       [ -s item_counts | -m item_dir_size ]
       [ -o | -c date | -u date | -d date ]
       [ -w ][ -r ][ -h ]

EOF;
}

/* 初期パラメータ */
$mapping ="";
$item_type_id = 0;
$item_type_name = "";
$index ="";
$id = "";
$recursive = false;
$split = 0;
$split_flag_s = false;
$split_flag_m = false;
$export_file = true;
$condition_type = 0;
$time = 0;
//config
$logfile = "";
$delimiter = "";
$uid = "";
$weko_item_names = array();
$class;
$output_file = "";

/* 入力処理 */
//コマンドライン引数の取得
$shortopts = "f:t:p:n:i:s:m:woc:u:d:rh";
/*
$longopts = array(
        "with-out-file",
        "only-delete-items",
        "create-date:",
        "update-date:",
        "delete-date:"
);
*/
$options = getopt($shortopts);

if (isset($options['h'])) {
	usage($argv[0]);
	exit();
}

//inifile
if (!isset($options['f'])) {
	fputs(STDERR, "ERROR no set ini_file\n");
	usage($argv[0]);
	exit();
} else {
	if (!file_exists($options['f'])) {
		fputs(STDERR, "ERROR no exists file ".$options['f']."\n");
		usage($argv[0]);
		exit();
	}
	$mapping = @parse_ini_file($options['f'], 1);
	if ( $mapping == false || empty($mapping) ) {
		fputs(STDERR, "ERROR failed parse ".$options['f']."\n");
		usage($argv[0]);
		exit();
	} else {
		//set config 
		//logfile
		if (isset($mapping['config']['logfile'])) {
			$logfile = $mapping['config']['logfile'];
		}
		if (empty($logfile)) {
			$logfile = "/var/log/xoonips2weko.log";
		}
		add_log("CONFIG logfile set ".$logfile."\n");
		//delimiter
		if (isset($mapping['config']['delimiter'])) {
			$delimiter = $mapping['config']['delimiter'];
		}
		if (empty($delimiter)) {
			$delimiter = "|";
		}
		add_log("CONFIG delimiter set ".$delimiter."\n");
		//uid
		if (isset($mapping['config']['uid'])) {
			$uid = $mapping['config']['uid'];
		}
		if (empty($uid)) {
			add_log("ERROR no set uid " . $options['f'] . "\n");
			usage($argv[0]);
			exit();
		}
		if (!is_moderator($uid)) {
			add_log("ERROR uid=$uid is not moderator\n");
			exit();
		}
		add_log("CONFIG uid set ".$uid."\n");
		//metadata 
/*
		if (!isset($mapping['metadata']) || empty($mapping['metadata'])) {
			add_log("ERROR no set metadata " . $options['f'] . "\n");
			exit();
		} else {
			$ret = metadata_valid($mapping['metadata']);
			if (!$ret) {
				add_log("ERROR " . $options['f'] . " metadata parse failed\n");
				exit();
			}
		}
*/
		//weko item name
		//Journal Article
		if (isset($mapping['config']['weko_item_name_journal_article'])) {
			$weko_item_names += array('journal_article' => mb_convert_encoding($mapping['config']['weko_item_name_journal_article'], mb_internal_encoding(), "auto"));
		} else {
			$weko_item_names += array('journal_article' => "");
		}
		//Thesis or Dissertation
                if (isset($mapping['config']['weko_item_name_thesis_or_Dissertation'])) {
                        $weko_item_names += array('thesis_or_Dissertation' => mb_convert_encoding($mapping['config']['weko_item_name_thesis_or_Dissertation'], mb_internal_encoding(), "auto"));
                } else {
                        $weko_item_names += array('thesis_or_Dissertation' => "");
                }
		//Departmental Bulletin Paper
                if (isset($mapping['config']['weko_item_name_departmental_bulletin_paper'])) {
                        $weko_item_names += array('departmental_bulletin_paper' => mb_convert_encoding($mapping['config']['weko_item_name_departmental_bulletin_paper'], mb_internal_encoding(), "auto"));
                } else {
                        $weko_item_names += array('departmental_bulletin_paper' => "");
                }
		//Conference Paper
                if (isset($mapping['config']['weko_item_name_conference_paper'])) {
                        $weko_item_names += array('conference_paper' => mb_convert_encoding($mapping['config']['weko_item_name_conference_paper'], mb_internal_encoding(), "auto"));
                } else {
                        $weko_item_names += array('conference_paper' => "");
                }
		//Presentation
                if (isset($mapping['config']['weko_item_name_presentation'])) {
                        $weko_item_names += array('presentation' => mb_convert_encoding($mapping['config']['weko_item_name_presentation'], mb_internal_encoding(), "auto"));
                } else {
                        $weko_item_names += array('presentation' => "");
                }
		//Book
                if (isset($mapping['config']['weko_item_name_book'])) {
                        $weko_item_names += array('book' => mb_convert_encoding($mapping['config']['weko_item_name_book'], mb_internal_encoding(), "auto"));
                } else {
                        $weko_item_names += array('book' => "");
                }
		//Technical Report
                if (isset($mapping['config']['weko_item_name_technical_report'])) {
                        $weko_item_names += array('technical_report' => mb_convert_encoding($mapping['config']['weko_item_name_technical_report'], mb_internal_encoding(), "auto"));
                } else {
                        $weko_item_names += array('technical_report' => "");
                }
		//Research Paper
                if (isset($mapping['config']['weko_item_name_research_paper'])) {
                        $weko_item_names += array('research_paper' => mb_convert_encoding($mapping['config']['weko_item_name_research_paper'], mb_internal_encoding(), "auto"));
                } else {
                        $weko_item_names += array('research_paper' => "");
                }
		//Article
                if (isset($mapping['config']['weko_item_name_article'])) {
                        $weko_item_names += array('article' => mb_convert_encoding($mapping['config']['weko_item_name_article'], mb_internal_encoding(), "auto"));
                } else {
                        $weko_item_names += array('article' => "");
                }
		//Preprint
                if (isset($mapping['config']['weko_item_name_preprint'])) {
                        $weko_item_names += array('preprint' => mb_convert_encoding($mapping['config']['weko_item_name_preprint'], mb_internal_encoding(), "auto"));
                } else {
                        $weko_item_names += array('preprint' => "");
                }
		//Learning Material
                if (isset($mapping['config']['weko_item_name_learning_material'])) {
                        $weko_item_names += array('learning_material' => mb_convert_encoding($mapping['config']['weko_item_name_learning_material'], mb_internal_encoding(), "auto"));
                } else {
                        $weko_item_names += array('learning_material' => "");
                }
		//Data or Dataset
                if (isset($mapping['config']['weko_item_name_data_or_dataset'])) {
                        $weko_item_names += array('data_or_dataset' => mb_convert_encoding($mapping['config']['weko_item_name_data_or_dataset'], mb_internal_encoding(), "auto"));
                } else {
                        $weko_item_names += array('data_or_dataset' => "");
                }
		//Software
                if (isset($mapping['config']['weko_item_name_software'])) {
                        $weko_item_names += array('software' => mb_convert_encoding($mapping['config']['weko_item_name_software'], mb_internal_encoding(), "auto"));
                } else {
                        $weko_item_names += array('software' => "");
                }
		//Others
                if (isset($mapping['config']['weko_item_name_others'])) {
                        $weko_item_names += array('others' => mb_convert_encoding($mapping['config']['weko_item_name_others'], mb_internal_encoding(), "auto"));
                } else {
                        $weko_item_names += array('others' => "");
                }
		add_log("CONFIG WEKO Item Name set\n");
	}
}

add_log("XooNIps Metadata Export Start\n");

//item type
if (!isset($options['t']) && !isset($options['p'])) {
	add_log("ERROR no set item type option t or p\n");
	usage($argv[0]);
	exit();
}

if (isset($options['t']) && isset($options['p'])) {
	add_log("ERROR can not specify both t and p\n");
	usage($argv[0]);
	exit();
}

if (isset($options['t'])) {
	if (preg_match("/\D/", $options['t'])) {
		add_log("ERROR -t must be set to a numeric value\n");
		usage($argv[0]);
		exit();
	}

	$item_type_id = (int)$options['t'];
	if ($item_type_id < 1) {
		add_log("ERROR -t Please enter a number that is greater than 1\n");
		usage($argv[0]);
		exit();
	}

	$item_type_name = get_item_type_name($item_type_id);
	if (!$item_type_name) {
		add_log("ERROR invalid item type\n");
		usage($argv[0]);
		exit();
	}
}

if (isset($options['p'])) {
	$item_type_name = ucfirst($options['p']);
	$item_type_id = get_item_type_id($item_type_name);
	if (!$item_type_id) {
		add_log("ERROR invalid item type\n");
		usage($argv[0]);
		exit();
	}
}

//index name
if (!isset($options['n'])) {
	if (!isset($options['i'])) {
		add_log("ERROR no set index option n or i\n");
		usage($argv[0]);
		exit();
	} else {
		if (preg_match("/\D/", $options['i'])) {
			add_log("ERROR -i must be set to a numeric value\n");
			usage($argv[0]);
			exit();
		} else {
			$id = (int)$options['i'];
			if ($id <= 0) {
				add_log("ERROR -i Please enter a number that is greater than 1\n");
				usage($argv[0]);
				exit();
			}
		}
	}
} else {
	$index = $options['n'];
}

//recursive
if (isset($options['r'])) {
	add_log("index recursive on\n");
	$recursive = true;
} else {
	$recursive = false;
}

//split
if (isset($options['s'])) {
	if (preg_match("/\D/", $options['s'])) {
		add_log("ERROR -s must be set to a numeric value\n");
		usage($argv[0]);
		exit();
	} else {
		$split = (int)$options['s'];
		if ($split <= 0) {
			add_log("ERROR -s Please enter a number that is greater than 1\n");
			usage($argv[0]);
			exit();
		}
	}
	$split_flag_s = true;
}

if (isset($options['m'])) {
	if (preg_match("/\D/", $options['m'])) {
		add_log("ERROR -m must be set to a numeric value\n");
		usage($argv[0]);
		exit();
	} else {
		$split = (int)$options['m'];
		if ($split <=0) {
			add_log("ERROR -m Please enter a number that is greater than 1\n");
			usage($argv[0]);
			exit();
		}
	}
	$split_flag_m = true;
}

if ( $split_flag_s && $split_flag_m) {
	add_log("ERROR split option set either s or m\n");
	usage($argv[0]);
	exit();
}

//export file
if (isset($options['w'])) {
        add_log("export file off\n");
        $export_file = false;
} else {
        $export_file = true;
}

//condition type
/* param setting
 * o          => 1
 * c          => 2
 * u          => 3
 * d          => 4
 */
$condition_type_chck = 0;
//only delete items
if (isset($options['o'])) {
	add_log("set export only delete items on\n");
	$condition_type = 1;
	$condition_type_chck++;
}
//create-date
if (isset($options['c'])) {
	$time = strtotime($options['c']);
	if (empty($time)) {
		add_log("ERROR create-date set YYYY-MM-DD or YYYYMMDD\n");
		usage($argv[0]);
		exit();
	}
	add_log("set export only create items since " . date('Y/m/d', $time). "\n");
	$condition_type = 2;
	$condition_type_chck++;
}
//update-date
if (isset($options['u'])) {
        $time = strtotime($options['u']);
        if (empty($time)) {
                add_log("ERROR update-date set YYYY-MM-DD or YYYYMMDD\n");
                usage($argv[0]);
                exit();
        }
	add_log("set export only update items since " . date('Y/m/d', $time). "\n");
	$condition_type = 3;
	$condition_type_chck++;
}
//delete-date
if (isset($options['d'])) {
        $time = strtotime($options['d']);
        if (empty($time)) {
                add_log("ERROR delete-date set YYYY-MM-DD or YYYYMMDD\n");
                usage($argv[0]);
                exit();
        }
	add_log("set export only delete items since " . date('Y/m/d', $time). "\n");
	$condition_type = 4;
	$condition_type_chck++;
}

if ($condition_type_chck > 1) {
	add_log("ERROR export conditions has multiple settings.\n");
	usage($argv[0]);
	exit();
}

//psを確認する
exec("ps axT|grep \"php .*xoonips2weko.php\"|grep -v grep|grep -v sudo|grep -v \"sh -c\"", $output, $result);
if (count($output) > 1) {
	add_log('Command Line Tool is already running'."\n");
	exit();
}

// /tmpにエクスポートしたアイテム(tar.gz)があるかを確認する
// 下へ移動
/*
$tgz = false;
foreach (glob("/tmp/item*.tar.gz") as $file) {
	if (file_exists($file) ) {
		$tgz = true;
		add_log("ERROR Export Item exists $file\n");
	}
}
if ($tgz) {
	exit();
}
*/

/* 変換処理 */
//xnparticleのitem_idを取得する
/*
$xnparticle = get_xnparticle_id();
if (!$xnparticle) {
	add_log("can not get xnparticle item_type_id \n");
	exit();
} else {
	add_log("xnparticle item_type_id = ".$xnparticle."\n");
}
*/

// アイテムタイプに対応したインスタンスを用意する
include_once XOONIPS2WEKO_PATH . "/class/ItemType$item_type_name.class.php";
$class_name = "Xoonips2weko_ItemType$item_type_name";
$class = new $class_name();

//変換ルールファイルの読み込み
$item_type_name_lower = strtolower($item_type_name);
if (isset($mapping['config']["rule_$item_type_name_lower"])) {
	$map_file = $mapping['config']["rule_$item_type_name_lower"];
	if (!file_exists($map_file)) {
		add_log("ERROR no exists file $map_file\n");
		exit();
	}
	$meta_tmp = @parse_ini_file($map_file);
	if ($meta_tmp == false || empty($meta_tmp)) {
		add_log("ERROR failed parse $map_file\n");
		exit();
	}
	$mapping['metadata'] = $meta_tmp;
} else {
	$meta_tmp = get_mapping($item_type_name);
	if ($meta_tmp == false || empty($meta_tmp))
		exit();
	$mapping['metadata'] = $meta_tmp;
}

//変換ルールファイルのチェック
$ret = $class->metadataValid($mapping['metadata']);
if (!$ret)
	exit();

// エクスポートするファイルが重複しないか確認
//$output_file = "xoonips_" . $item_type_name;
//$ret = glob("/tmp/$output_file*.tar.gz");
$ret = find_old_files($item_type_name);
if (!empty($ret)) {
	$answer = "";
	fputs(STDOUT, "Exported file ($item_type_name) exists at /tmp. Overwrite? (y/n): ");
	while (empty($answer)) {
		$line = trim(fgets(STDIN));
		if ($line === "y")
			$answer = $line;
		else if ($line === "n") {
			add_log("Export canceled\n");
			exit();
		} else {
			fputs(STDOUT, "Enter y or n: ");
		}
	}

	// 重複ファイルを削除
	$ret = delete_old_files($item_type_name);
	if (!$ret)
		exit();
/*
	foreach ($ret as $f) {
		if (!unlink($f)) {
			add_log("ERROR can not delete $f\n");
			exit();
		}
	}
*/
}

//インデックス名からインデックスidを取得する
if (isset($id) && $id != "") {
	$index_id = $id;
	add_log("index_id = " . $index_id . "\n");
} else {
	$index_id = get_index_id($index);
}
if ( $index_id == null ) {
	add_log("ERROR can not get index_id: $index\n");
	exit();
} else {
	if (!empty($index)) {
		add_log($index . ": index_id = " . $index_id . "\n");
	}
}

//インデックス名と再帰フラグからエクスポートするアイテムidを取得する
$item_ids = get_item_ids($index_id, $recursive);
$item_ids = array_unique( $item_ids );
$item_ids = filter_by_item_type_id($item_ids, $item_type_id);

$all_item_ids = count($item_ids);
if ( $all_item_ids == 0) {
	add_log("item does not exists\n");
	exit();
} else {
	add_log("total items = " . $all_item_ids . "\n");
}

//Split Loop Start
add_log("item export start\n");
$split_count = 1;
$total_export_item = 0;
$total_skip_item = 0;
while (!empty($item_ids)) {

	//ITEM出力フォルダの番号
	$dir_num = sprintf("%03d", $split_count++);

	//アイテムの一時格納ディレクトリを作成する
	$item_dir = make_item_dir($dir_num); 
	if (!$item_dir) { 
		add_log("can not temp mkdir \n");
		exit();
	}

	//TSVファイルを作成する
	$tsvfile = "${item_dir}/metadata.tsv";

	$fhdl = fopen($tsvfile, 'w');
	if (!$fhdl) {
		add_log("can not open file '${tsvfile}' for write. \n");
		exit();
	}

	//TSVファイルにBOMを追加する
	fwrite ($fhdl, pack('C*', 0xEF, 0xBB, 0xBF));

	//mapping.iniに従ってTSVファイルにヘッダを追加する。
	//サニタイズ処理
	metadata_sanitize($mapping['metadata']);
	$headers = make_tsv_record_str($mapping['metadata']);
	$headers = $headers."\n";
	$headers = mb_convert_encoding($headers, "UTF-8", "auto");
	fwrite ($fhdl, $headers);

	//抽出するアイテム全件
	$total_item_ids = count($item_ids);
	//分割オプション
	//s
	if ($split_flag_s && $split <= $total_item_ids ) {
		$total_item_ids = $split;
	}
	//m
	$file_size = 0;
	$item_m_count = 0;
	if ($split_flag_m) {
		foreach ($item_ids as $item_id) {
			$item_m_count++;
			$file_size += get_file_size($item_id);
			if ($split < $file_size) {
				$item_m_count--;
				break;
			}
		}
		if ( $item_m_count <= $total_item_ids ) {
			$total_item_ids = $item_m_count;
		}
		if ( $total_item_ids == 0 ) {
			$total_item_ids = 1;
		}
	}
	add_log("number of export item " . $total_item_ids  . "\n");

	//itemのレコードを記載する
	$item_id_count = 0;
	$export_metadata_count = 0;
	$export_item_count = 0;
	$skip_item_count = 0;
	foreach ($item_ids as $key => $item_id) {
		//アイテムのメタデータを格納するオブジェクトをマッピングテーブルから作成する
		$metadata = array();
		$ret = make_metadata_format($mapping , $metadata);
		if (!$ret){
			add_log("can not get metadata format $item_id \n");
			unset($item_ids[$key]);
			$skip_item_count++;
			continue;
		}
		//アイテム情報を取得する
		//$ret = export_item_metadata($item_id, $xnparticle, $metadata);
		$ret = $class->exportItemMetadata($item_id, $metadata);
		if ( !$ret ) {
			add_log("can not get metadata ITEM_KEY: $item_id. Skip. \n");
			$skip_item_count++;
			unset($item_ids[$key]);
			continue;
		} else if ($ret === 2) {
			add_log("ITEM_KEY: $item_id is not $item_type_name item type. Skip.\n");
			$skip_item_count++;
			unset($item_ids[$key]);
			continue;
		} else {
			add_log("export metadata ITEM_KEY: $item_id \n");
			//アイテムの本文ファイルをエクスポートディレクトリにコピーする
			//$ret = export_item_file($dir_num, $item_dir, $item_id, $metadata);
			if ( $export_file ) {
				$ret = $class->exportItemFile($item_id, $item_dir, $metadata);
				if ( !$ret ) {
					add_log("can not get file ITEM_KEY: $item_id \n");
				} else if ($ret === 2) {
					add_log("no files ITEM_KEY: $item_id \n");
				}
			}
			//アイテム情報をTSVファイルに記載する
			//サニタイズ
			metadata_sanitize($metadata);
			$metadata_tsv_record = make_tsv_record_str($metadata);
			$metadata_tsv_record = $metadata_tsv_record."\n";
			$metadata_tsv_record = mb_convert_encoding($metadata_tsv_record, "UTF-8", "auto");
			fwrite ($fhdl, $metadata_tsv_record);
			$item_id_count++;
			add_log("record metadata ". $item_id_count . "/" . $total_item_ids . "\n");
			$export_item_count++;
		}

		//出力するファイル数をもとめる
		$file = get_file_info($item_id);
		$export_metadata_count += count($file);

		unset($item_ids[$key]);

		//split flag true
		if ($split_flag_s && $split <= $item_id_count) {
			break;
		}
		if ($split_flag_m && $item_m_count <= $item_id_count) {
			break;
		}

	}
	fclose($fhdl);
	$total_export_item = $total_export_item + $export_item_count;
	$total_skip_item = $total_skip_item + $skip_item_count;

	/* 出力処理 */
	//エクスポートディレクトリをtar.gz形式に変換する
	$tgzname = "xoonips_" . $item_type_name . "_" . date("Ymd") . "_" . $dir_num . ".tar.gz";
	add_log("make $tgzname.... \n");
	$cmd = "cd /tmp; tar cvzf $tgzname item${dir_num}";
	$hdl = popen($cmd, 'r');
	$export_metadata = 1;
	while (!feof($hdl)) {
        	$log = fgets($hdl);
		$log =  mb_convert_encoding($log, "UTF-8", "auto");
		if (!empty($log)) {
			if (!preg_match("/\/$/", $log)) {
				if (!preg_match("/metadata.tsv/", $log)) {
					$export_msg = rtrim($log);
					$log = $export_msg . " " . $export_metadata . "/" . $export_metadata_count . " \n";
					$export_metadata++;
				}
			}
			add_log($log);
		}
	}
	pclose($hdl);

	//テンポラリの削除
	add_log("delete tmp dir item${dir_num}.... \n");
	$cmd = "rm -fvr ${item_dir}";
	$hdl = popen($cmd, 'r');
	while (!feof($hdl)) {
		$log = fgets($hdl);
		$log =  mb_convert_encoding($log, "UTF-8", "auto");
		if (!empty($log)) {
			add_log($log);
		}
	}
}
add_log("export end  all items: ".$all_item_ids." export items: ".$total_export_item." skip items: ".$total_skip_item."\n");
add_log("XooNIps Metadata Export End\n");
exit();

